var gulp = require('gulp');
var eslint = require('gulp-eslint');
var gulpIf = require('gulp-if');

gulp.task('eslint', () => {
    return gulp.src('./exampleCode.js')
    .pipe(eslint())
    .pipe(eslint.format())
    .pipe(eslint.failAfterError())
});


function isFixed(file) {
    return file.eslint != null && file.eslint.fixed; // Has ESLint fixed the file contents?
}

gulp.task('eslint-fix', () => {
    return gulp.src('./exampleCode.js')
    .pipe(eslint({
        fix: true, 
    }))
    .pipe(eslint.format())
    .pipe(gulpIf(isFixed, gulp.dest('./'))) // if running fix - replace existing file with fixed one
    .pipe(eslint.failAfterError())
});


/*
// Advanced multi purpose task 
// note this requires you to install a new dependency by running `npm i yargs --save-dev`
// Also remove / comment out the `eslint` task on line 5 if using this one

var argv = require('yargs').argv; // move this to the top of gulpfile with other variables if used

gulp.task('eslint', () => {
    var target = argv.file ? argv.file : './exampleCode.js';
    var fixCode = argv.fix ? true : false;

    return gulp.src(target, {base: "./"})
    .pipe(eslint({
        fix: fixCode, 
    }))
    .pipe(eslint.format())
    .pipe(gulpIf(isFixed, gulp.dest('./')))
    .pipe(eslint.failAfterError())
});

// usage 
// gulp eslint                                      // lint  all
// gulp eslint --fix                                // lint + fix all
// gulp eslint --file ./folder/filename.js          // lint file
// gulp eslint --file ./folder/filename.js --fix    // lint + fix file 

*/